/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 508:  /* *p atomic_fetch_xordi */
    case 507:  /* *p atomic_fetch_ordi */
    case 506:  /* *p atomic_fetch_anddi */
    case 505:  /* *p atomic_fetch_xorsi */
    case 504:  /* *p atomic_fetch_orsi */
    case 503:  /* *p atomic_fetch_andsi */
    case 502:  /* *p atomic_fetch_addsf */
    case 501:  /* *p atomic_fetch_adddi */
    case 500:  /* *p atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 499:  /* *p atomic_exchangedi */
    case 498:  /* *p atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 497:  /* *p atomic_compare_and_swapdi_1 */
    case 496:  /* *p atomic_compare_and_swapsi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 3));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XEXP (pat, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 493:  /* *p unpackdfsi2 */
    case 492:  /* *p unpackdisi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 2;
      break;

    case 491:  /* *p omp_simt_lane */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 485:  /* *p nvptx_shufflesf */
    case 484:  /* *p nvptx_shufflesi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 490:  /* *p omp_simt_exit_di */
    case 489:  /* *p omp_simt_exit_si */
    case 480:  /* *p set_softstack_di */
    case 479:  /* *p set_softstack_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 481:  /* *p trap */
    case 478:  /* *p fake_nop */
    case 477:  /* *p exit */
    case 476:  /* *p nop */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 495:  /* *p packsidf2 */
    case 494:  /* *p packsidi2 */
    case 488:  /* *p omp_simt_enter_di */
    case 487:  /* *p omp_simt_enter_si */
    case 427:  /* *p copysigndf3 */
    case 426:  /* *p copysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 423:  /* *p fmadf4 */
    case 422:  /* *p fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 415:  /* *p call_value_insn_di */
    case 414:  /* *p call_value_insn_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 413:  /* *p call_insn_di */
    case 412:  /* *p call_insn_si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 401:  /* *p sel_falsedf */
    case 400:  /* *p sel_falsesf */
    case 399:  /* *p sel_falsedi */
    case 398:  /* *p sel_falsesi */
    case 397:  /* *p sel_falsehi */
    case 396:  /* *p sel_truedf */
    case 395:  /* *p sel_truesf */
    case 394:  /* *p sel_truedi */
    case 393:  /* *p sel_truesi */
    case 392:  /* *p sel_truehi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 390:  /* *p jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 411:  /* *p setcc_floatdf */
    case 410:  /* *p setcc_floatsf */
    case 409:  /* *p setcc_floatdi */
    case 408:  /* *p setcc_floatsi */
    case 407:  /* *p setcc_floathi */
    case 406:  /* *p setcc_intdf */
    case 405:  /* *p setcc_intsf */
    case 404:  /* *p setcc_intdi */
    case 403:  /* *p setcc_intsi */
    case 402:  /* *p setcc_inthi */
    case 389:  /* *p *cmpdf */
    case 388:  /* *p *cmpsf */
    case 387:  /* *p *cmpdi */
    case 386:  /* *p *cmpsi */
    case 385:  /* *p *cmphi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 329:  /* *p *maddi3 */
    case 328:  /* *p *madsi3 */
    case 327:  /* *p *madhi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 431:  /* *p smaxdf3 */
    case 430:  /* *p smaxsf3 */
    case 429:  /* *p smindf3 */
    case 428:  /* *p sminsf3 */
    case 425:  /* *p divdf3 */
    case 424:  /* *p divsf3 */
    case 421:  /* *p muldf3 */
    case 420:  /* *p mulsf3 */
    case 419:  /* *p subdf3 */
    case 418:  /* *p subsf3 */
    case 417:  /* *p adddf3 */
    case 416:  /* *p addsf3 */
    case 384:  /* *p xordi3 */
    case 383:  /* *p xorsi3 */
    case 382:  /* *p xorhi3 */
    case 381:  /* *p xorbi3 */
    case 380:  /* *p iordi3 */
    case 379:  /* *p iorsi3 */
    case 378:  /* *p iorhi3 */
    case 377:  /* *p iorbi3 */
    case 376:  /* *p anddi3 */
    case 375:  /* *p andsi3 */
    case 374:  /* *p andhi3 */
    case 373:  /* *p andbi3 */
    case 372:  /* *p lshrdi3 */
    case 371:  /* *p lshrsi3 */
    case 370:  /* *p ashrdi3 */
    case 369:  /* *p ashrsi3 */
    case 368:  /* *p ashldi3 */
    case 367:  /* *p ashlsi3 */
    case 353:  /* *p umaxdi3 */
    case 352:  /* *p umaxsi3 */
    case 351:  /* *p umaxhi3 */
    case 350:  /* *p smaxdi3 */
    case 349:  /* *p smaxsi3 */
    case 348:  /* *p smaxhi3 */
    case 347:  /* *p umindi3 */
    case 346:  /* *p uminsi3 */
    case 345:  /* *p uminhi3 */
    case 344:  /* *p smindi3 */
    case 343:  /* *p sminsi3 */
    case 342:  /* *p sminhi3 */
    case 341:  /* *p umoddi3 */
    case 340:  /* *p umodsi3 */
    case 339:  /* *p umodhi3 */
    case 338:  /* *p moddi3 */
    case 337:  /* *p modsi3 */
    case 336:  /* *p modhi3 */
    case 335:  /* *p udivdi3 */
    case 334:  /* *p udivsi3 */
    case 333:  /* *p udivhi3 */
    case 332:  /* *p divdi3 */
    case 331:  /* *p divsi3 */
    case 330:  /* *p divhi3 */
    case 326:  /* *p muldi3 */
    case 325:  /* *p mulsi3 */
    case 324:  /* *p mulhi3 */
    case 323:  /* *p subdi3 */
    case 322:  /* *p subsi3 */
    case 321:  /* *p subhi3 */
    case 320:  /* *p adddi3 */
    case 319:  /* *p addsi3 */
    case 318:  /* *p addhi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 459:  /* *p fix_truncdfdi2 */
    case 458:  /* *p fix_truncsfdi2 */
    case 457:  /* *p fixuns_truncdfdi2 */
    case 456:  /* *p fixuns_truncsfdi2 */
    case 455:  /* *p fix_truncdfsi2 */
    case 454:  /* *p fix_truncsfsi2 */
    case 453:  /* *p fixuns_truncdfsi2 */
    case 452:  /* *p fixuns_truncsfsi2 */
    case 451:  /* *p floatdidf2 */
    case 450:  /* *p floatdisf2 */
    case 449:  /* *p floatunsdidf2 */
    case 448:  /* *p floatunsdisf2 */
    case 447:  /* *p floatsidf2 */
    case 446:  /* *p floatsisf2 */
    case 445:  /* *p floatunssidf2 */
    case 444:  /* *p floatunssisf2 */
    case 443:  /* *p truncdfsf2 */
    case 442:  /* *p extendsfdf2 */
    case 437:  /* *p sqrtdf2 */
    case 436:  /* *p sqrtsf2 */
    case 435:  /* *p negdf2 */
    case 434:  /* *p negsf2 */
    case 433:  /* *p absdf2 */
    case 432:  /* *p abssf2 */
    case 391:  /* *p setcc_from_bi */
    case 366:  /* *p clzdi2 */
    case 365:  /* *p clzsi2 */
    case 362:  /* *p one_cmpldi2 */
    case 361:  /* *p one_cmplsi2 */
    case 360:  /* *p one_cmplhi2 */
    case 359:  /* *p negdi2 */
    case 358:  /* *p negsi2 */
    case 357:  /* *p neghi2 */
    case 356:  /* *p absdi2 */
    case 355:  /* *p abssi2 */
    case 354:  /* *p abshi2 */
    case 317:  /* *p truncdisi2 */
    case 316:  /* *p truncdihi2 */
    case 315:  /* *p truncdiqi2 */
    case 314:  /* *p truncsihi2 */
    case 313:  /* *p truncsiqi2 */
    case 312:  /* *p trunchiqi2 */
    case 311:  /* *p extendsidi2 */
    case 310:  /* *p extendhidi2 */
    case 309:  /* *p extendqidi2 */
    case 308:  /* *p extendhisi2 */
    case 307:  /* *p extendqisi2 */
    case 306:  /* *p zero_extendsidi2 */
    case 305:  /* *p zero_extendhidi2 */
    case 304:  /* *p zero_extendqidi2 */
    case 303:  /* *p zero_extendhisi2 */
    case 302:  /* *p zero_extendqisi2 */
    case 301:  /* *p zero_extendqihi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 486:  /* *p nvptx_vote_ballot */
    case 483:  /* *p oacc_dim_pos */
    case 482:  /* *p oacc_dim_size */
    case 475:  /* *p lceildfdi2 */
    case 474:  /* *p lfloordfdi2 */
    case 473:  /* *p lceilsfdi2 */
    case 472:  /* *p lfloorsfdi2 */
    case 471:  /* *p lceildfsi2 */
    case 470:  /* *p lfloordfsi2 */
    case 469:  /* *p lceilsfsi2 */
    case 468:  /* *p lfloorsfsi2 */
    case 467:  /* *p nearbyintdf2 */
    case 466:  /* *p ceildf2 */
    case 465:  /* *p btruncdf2 */
    case 464:  /* *p floordf2 */
    case 463:  /* *p nearbyintsf2 */
    case 462:  /* *p ceilsf2 */
    case 461:  /* *p btruncsf2 */
    case 460:  /* *p floorsf2 */
    case 441:  /* *p exp2sf2 */
    case 440:  /* *p log2sf2 */
    case 439:  /* *p cossf2 */
    case 438:  /* *p sinsf2 */
    case 364:  /* *p bitrevdi2 */
    case 363:  /* *p bitrevsi2 */
    case 300:  /* *p load_arg_regdf */
    case 299:  /* *p load_arg_regsf */
    case 298:  /* *p load_arg_regdi */
    case 297:  /* *p load_arg_regsi */
    case 296:  /* *p load_arg_reghi */
    case 295:  /* *p load_arg_regqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 294:  /* *p *movdf_insn */
    case 293:  /* *p *movsf_insn */
    case 292:  /* *p *movdi_insn */
    case 291:  /* *p *movsi_insn */
    case 290:  /* *p *movhi_insn */
    case 289:  /* *p *movqi_insn */
    case 288:  /* *p *movv2di_insn */
    case 287:  /* *p *movv2si_insn */
    case 286:  /* *p movbi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 237:  /* *nvptx_membar_cta */
    case 236:  /* *memory_barrier */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 235:  /* nvptx_barsync */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 234:  /* atomic_fetch_xordi */
    case 233:  /* atomic_fetch_ordi */
    case 232:  /* atomic_fetch_anddi */
    case 231:  /* atomic_fetch_xorsi */
    case 230:  /* atomic_fetch_orsi */
    case 229:  /* atomic_fetch_andsi */
    case 228:  /* atomic_fetch_addsf */
    case 227:  /* atomic_fetch_adddi */
    case 226:  /* atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 225:  /* atomic_exchangedi */
    case 224:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 223:  /* atomic_compare_and_swapdi_1 */
    case 222:  /* atomic_compare_and_swapsi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 3));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 219:  /* unpackdfsi2 */
    case 218:  /* unpackdisi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 2;
      break;

    case 217:  /* omp_simt_lane */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 211:  /* nvptx_shufflesf */
    case 210:  /* nvptx_shufflesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 203:  /* trap_if_false */
    case 202:  /* trap_if_true */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 216:  /* omp_simt_exit_di */
    case 215:  /* omp_simt_exit_si */
    case 209:  /* nvptx_join */
    case 208:  /* nvptx_joining */
    case 207:  /* nvptx_forked */
    case 206:  /* nvptx_fork */
    case 200:  /* set_softstack_di */
    case 199:  /* set_softstack_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 238:  /* nvptx_nounroll */
    case 201:  /* trap */
    case 198:  /* return */
    case 197:  /* fake_nop */
    case 196:  /* exit */
    case 195:  /* nop */
      break;

    case 221:  /* packsidf2 */
    case 220:  /* packsidi2 */
    case 214:  /* omp_simt_enter_di */
    case 213:  /* omp_simt_enter_si */
    case 146:  /* copysigndf3 */
    case 145:  /* copysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 142:  /* fmadf4 */
    case 141:  /* fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 134:  /* call_value_insn_di */
    case 133:  /* call_value_insn_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &PATTERN (insn));
      break;

    case 132:  /* call_insn_di */
    case 131:  /* call_insn_si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &PATTERN (insn));
      break;

    case 120:  /* sel_falsedf */
    case 119:  /* sel_falsesf */
    case 118:  /* sel_falsedi */
    case 117:  /* sel_falsesi */
    case 116:  /* sel_falsehi */
    case 115:  /* sel_truedf */
    case 114:  /* sel_truesf */
    case 113:  /* sel_truedi */
    case 112:  /* sel_truesi */
    case 111:  /* sel_truehi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 109:  /* br_false_uni */
    case 108:  /* br_true_uni */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 107:  /* br_false */
    case 106:  /* br_true */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 105:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 130:  /* setcc_floatdf */
    case 129:  /* setcc_floatsf */
    case 128:  /* setcc_floatdi */
    case 127:  /* setcc_floatsi */
    case 126:  /* setcc_floathi */
    case 125:  /* setcc_intdf */
    case 124:  /* setcc_intsf */
    case 123:  /* setcc_intdi */
    case 122:  /* setcc_intsi */
    case 121:  /* setcc_inthi */
    case 104:  /* *cmpdf */
    case 103:  /* *cmpsf */
    case 102:  /* *cmpdi */
    case 101:  /* *cmpsi */
    case 100:  /* *cmphi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 44:  /* *maddi3 */
    case 43:  /* *madsi3 */
    case 42:  /* *madhi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 150:  /* smaxdf3 */
    case 149:  /* smaxsf3 */
    case 148:  /* smindf3 */
    case 147:  /* sminsf3 */
    case 144:  /* divdf3 */
    case 143:  /* divsf3 */
    case 140:  /* muldf3 */
    case 139:  /* mulsf3 */
    case 138:  /* subdf3 */
    case 137:  /* subsf3 */
    case 136:  /* adddf3 */
    case 135:  /* addsf3 */
    case 99:  /* xordi3 */
    case 98:  /* xorsi3 */
    case 97:  /* xorhi3 */
    case 96:  /* xorbi3 */
    case 95:  /* iordi3 */
    case 94:  /* iorsi3 */
    case 93:  /* iorhi3 */
    case 92:  /* iorbi3 */
    case 91:  /* anddi3 */
    case 90:  /* andsi3 */
    case 89:  /* andhi3 */
    case 88:  /* andbi3 */
    case 87:  /* lshrdi3 */
    case 86:  /* lshrsi3 */
    case 85:  /* ashrdi3 */
    case 84:  /* ashrsi3 */
    case 83:  /* ashldi3 */
    case 82:  /* ashlsi3 */
    case 68:  /* umaxdi3 */
    case 67:  /* umaxsi3 */
    case 66:  /* umaxhi3 */
    case 65:  /* smaxdi3 */
    case 64:  /* smaxsi3 */
    case 63:  /* smaxhi3 */
    case 62:  /* umindi3 */
    case 61:  /* uminsi3 */
    case 60:  /* uminhi3 */
    case 59:  /* smindi3 */
    case 58:  /* sminsi3 */
    case 57:  /* sminhi3 */
    case 56:  /* umoddi3 */
    case 55:  /* umodsi3 */
    case 54:  /* umodhi3 */
    case 53:  /* moddi3 */
    case 52:  /* modsi3 */
    case 51:  /* modhi3 */
    case 50:  /* udivdi3 */
    case 49:  /* udivsi3 */
    case 48:  /* udivhi3 */
    case 47:  /* divdi3 */
    case 46:  /* divsi3 */
    case 45:  /* divhi3 */
    case 41:  /* muldi3 */
    case 40:  /* mulsi3 */
    case 39:  /* mulhi3 */
    case 38:  /* subdi3 */
    case 37:  /* subsi3 */
    case 36:  /* subhi3 */
    case 35:  /* adddi3 */
    case 34:  /* addsi3 */
    case 33:  /* addhi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 178:  /* fix_truncdfdi2 */
    case 177:  /* fix_truncsfdi2 */
    case 176:  /* fixuns_truncdfdi2 */
    case 175:  /* fixuns_truncsfdi2 */
    case 174:  /* fix_truncdfsi2 */
    case 173:  /* fix_truncsfsi2 */
    case 172:  /* fixuns_truncdfsi2 */
    case 171:  /* fixuns_truncsfsi2 */
    case 170:  /* floatdidf2 */
    case 169:  /* floatdisf2 */
    case 168:  /* floatunsdidf2 */
    case 167:  /* floatunsdisf2 */
    case 166:  /* floatsidf2 */
    case 165:  /* floatsisf2 */
    case 164:  /* floatunssidf2 */
    case 163:  /* floatunssisf2 */
    case 162:  /* truncdfsf2 */
    case 161:  /* extendsfdf2 */
    case 156:  /* sqrtdf2 */
    case 155:  /* sqrtsf2 */
    case 154:  /* negdf2 */
    case 153:  /* negsf2 */
    case 152:  /* absdf2 */
    case 151:  /* abssf2 */
    case 110:  /* setcc_from_bi */
    case 81:  /* clzdi2 */
    case 80:  /* clzsi2 */
    case 77:  /* one_cmpldi2 */
    case 76:  /* one_cmplsi2 */
    case 75:  /* one_cmplhi2 */
    case 74:  /* negdi2 */
    case 73:  /* negsi2 */
    case 72:  /* neghi2 */
    case 71:  /* absdi2 */
    case 70:  /* abssi2 */
    case 69:  /* abshi2 */
    case 32:  /* truncdisi2 */
    case 31:  /* truncdihi2 */
    case 30:  /* truncdiqi2 */
    case 29:  /* truncsihi2 */
    case 28:  /* truncsiqi2 */
    case 27:  /* trunchiqi2 */
    case 26:  /* extendsidi2 */
    case 25:  /* extendhidi2 */
    case 24:  /* extendqidi2 */
    case 23:  /* extendhisi2 */
    case 22:  /* extendqisi2 */
    case 21:  /* zero_extendsidi2 */
    case 20:  /* zero_extendhidi2 */
    case 19:  /* zero_extendqidi2 */
    case 18:  /* zero_extendhisi2 */
    case 17:  /* zero_extendqisi2 */
    case 16:  /* zero_extendqihi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 239:  /* nvptx_red_partition */
    case 212:  /* nvptx_vote_ballot */
    case 205:  /* oacc_dim_pos */
    case 204:  /* oacc_dim_size */
    case 194:  /* lceildfdi2 */
    case 193:  /* lfloordfdi2 */
    case 192:  /* lceilsfdi2 */
    case 191:  /* lfloorsfdi2 */
    case 190:  /* lceildfsi2 */
    case 189:  /* lfloordfsi2 */
    case 188:  /* lceilsfsi2 */
    case 187:  /* lfloorsfsi2 */
    case 186:  /* nearbyintdf2 */
    case 185:  /* ceildf2 */
    case 184:  /* btruncdf2 */
    case 183:  /* floordf2 */
    case 182:  /* nearbyintsf2 */
    case 181:  /* ceilsf2 */
    case 180:  /* btruncsf2 */
    case 179:  /* floorsf2 */
    case 160:  /* exp2sf2 */
    case 159:  /* log2sf2 */
    case 158:  /* cossf2 */
    case 157:  /* sinsf2 */
    case 79:  /* bitrevdi2 */
    case 78:  /* bitrevsi2 */
    case 15:  /* load_arg_regdf */
    case 14:  /* load_arg_regsf */
    case 13:  /* load_arg_regdi */
    case 12:  /* load_arg_regsi */
    case 11:  /* load_arg_reghi */
    case 10:  /* load_arg_regqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 9:  /* *movdf_insn */
    case 8:  /* *movsf_insn */
    case 7:  /* *movdi_insn */
    case 6:  /* *movsi_insn */
    case 5:  /* *movhi_insn */
    case 4:  /* *movqi_insn */
    case 3:  /* *movv2di_insn */
    case 2:  /* *movv2si_insn */
    case 1:  /* movbi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
